#include <iostream>
#include <fstream>

using namespace std;


int main(int argc,char** argv){
  //Syntaxe correcte
  //Attention l'argument 0 est le nom du programme
  if(argc!=2){
    cout<<"Usage : \033[32mstat fichier_chiffre\033[30m"<<endl;
    return -1;
  }

  //Rcupration des arguments
  string nomFichierChiffre(argv[1]);
  
  //Ouverture du fichier chiffre pour lecture
  fstream fichierChiffre;
  fichierChiffre.open(nomFichierChiffre.c_str(),ios::in);
  if(!fichierChiffre.is_open()){
    cout<<"\033[31mErreur\033[30m : Impossible d'ouvrir le fichier \033[32m"<<nomFichierChiffre<<"\033[30m en lecture."<<endl;
    return -4;
  }

  unsigned short int nombre[26];
  unsigned short int i;
  for(i=0;i<26;i++){
    nombre[i]=0;
  }
  char caractereChiffre;
  //Parcours des caractres du fichier chiffre
  while(fichierChiffre.read(&caractereChiffre,1)>0){
    //La caractre caractereClair est-il une lettre minuscule ?
    if(caractereChiffre>='a' && caractereChiffre<='z'){
      nombre[caractereChiffre-'a']++;
    }
    //Sinon, est-il une lettre majuscule ?
    else if(caractereChiffre>='A' && caractereChiffre<='Z'){
      //Si oui on le dcale de dcalage
      nombre[caractereChiffre-'a']++;
    }
  }
  
 

  //On trie le tableau nombre par tri par slction
  unsigned int j,m,l;
  char cle;
  for(i=0;i<26;i++){
    m=nombre[i];l=i;
    for(j=0;j<26;j++){
      if(nombre[j]>m){
	m=nombre[j];
	l=j;
      }
    }
    nombre[l]=0;
    cle='a'+l-'e'+'a';
    if(cle>'z' || cle<0){
      cle-=26;
    }
    if(cle<'a'){
      cle+=26;
    }
    cout<<(char)('a'+l)<<" -> "<<m<<" => cle = "<<cle<<endl;
  }

  //On ferme les fichiers
  fichierChiffre.close();
}
